// java TimeTest jdbc:postgresql:database user password 
import java.sql.*;
public class TimeTest {
	public static void main(String[] args) {
		String pg71[] = {
			"select 'now'::timestamp with time zone",
			"select 'now'::timestamp without time zone",
			"select 'now'::time without time zone",
			"select 'now'::time with time zone"
		};
		String pg72[] = {
			"select 'now'::timestamp(0) with time zone",
			"select 'now'::timestamp(0) without time zone",
			"select 'now'::time(0) without time zone",
			"select 'now'::time(0) with time zone",
			"select 'now'::timestamp(4) with time zone",
			"select 'now'::timestamp(4) without time zone",
			"select 'now'::time(4) without time zone",
			"select 'now'::time(4) with time zone",
			"select 'now'::timestamp(10) with time zone",
			"select 'now'::timestamp(10) without time zone",
			"select 'now'::time(10) without time zone",
			"select 'now'::time(10) with time zone"
		};
		try {
			Class.forName("org.postgresql.Driver");
			Connection db = DriverManager.getConnection(args[0], args[1], args[2]);
			for (int i = 0; i < pg71.length; i++) {
				Statement st = db.createStatement();
				ResultSet rs = st.executeQuery(pg71[i]);
				rs.next();
				Time time = rs.getTime(1);
				System.out.println(pg71[i] + " --> " + time);
				rs.close();
				st.close();
			}
			if (((org.postgresql.Connection) db).haveMinimumServerVersion("7.2")) {
				for (int i = 0; i < pg72.length; i++) {
					Statement st = db.createStatement();
					ResultSet rs = st.executeQuery(pg72[i]);
					rs.next();
					Time time = rs.getTime(1);
					System.out.println(pg72[i] + " --> " + time);
					rs.close();
					st.close();
				}
			}
			db.close();
		} catch (Exception e) {
			System.out.println(e);
		}
	}
}
